/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.common.dao;

import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import jp.mosp.common.common.BaseDao;
import jp.mosp.common.common.MospException;
import jp.mosp.common.dto.CmComponentDto;

/**
 * CM_COMPONENT(メニューコマンドマスタ)のDAOクラス 。
 */
public class CmComponentDao extends BaseDao {
	
	// テーブル名及びキー列名
	/**
	 * CM_COMPONENT(メニューコマンドマスタ)。
	 */
	public static final String	TABLE			= "CM_COMPONENT";
	
	/**
	 * KEY_1 = COMPCODE(コマンドユニットコード)。
	 */
	public static final String	KEY_1			= "COMPCODE";
	
	// 列名
	/**
	 * COMPCODE(コマンドユニットコード)。
	 */
	public static final String	COL_COMPCODE	= "COMPCODE";
	/**
	 * DIVISION(分類)。
	 */
	public static final String	COL_DIVISION	= "DIVISION";
	/**
	 * COMPNAME(コマンドユニットネーム)。
	 */
	public static final String	COL_COMPNAME	= "COMPNAME";
	/**
	 * COMPONENT(コマンド)。
	 */
	public static final String	COL_COMPONENT	= "COMPONENT";
	/**
	 * MANAGE(利用範囲)。
	 */
	public static final String	COL_MANAGE		= "MANAGE";
	/**
	 * DELETEFLAG(削除フラグ)。
	 */
	public static final String	COL_DELETEFLAG	= "DELETEFLAG";
	

	/**
	 * コンストラクタ
	 */
	public CmComponentDao() {
		super();
	}
	
	/**
	 * 検索結果取得(DTOのList)
	 * @return List 検索リスト
	 * @throws SQLException SQL例外が発生した場合
	 */
	private List<CmComponentDto> mappingAll() throws SQLException {
		List<CmComponentDto> all = new ArrayList<CmComponentDto>();
		while (rs.next()) {
			all.add(mapping());
		}
		return all;
	}
	
	/**
	 * 検索結果取得(DTO)
	 * @return cm_componentDto cm_componentレコード
	 * @throws SQLException SQL例外が発生した場合
	 */
	private CmComponentDto mapping() throws SQLException {
		CmComponentDto dto = new CmComponentDto();
		dto.setCompCode(rs.getString(COL_COMPCODE)); //コマンドユニットコード
		dto.setDivision(rs.getString(COL_DIVISION)); //分類
		dto.setCompName(rs.getString(COL_COMPNAME)); //コマンドユニットネーム
		dto.setComponent(rs.getString(COL_COMPONENT)); //コマンド
		dto.setManage(rs.getInt(COL_MANAGE)); //閲覧権限
		dto.setDeleteFlag(rs.getInt(COL_DELETEFLAG)); //削除フラグ
		return dto;
	}
	
	/**
	 * 全データ取得
	 * @return List 検索結果(DTOのList)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 */
	public List<?> findAll() throws SQLException, IllegalAccessException, NoSuchFieldException {
		try {
			prepareStatement(getSelectQuery(getClass()) + getOrderForKey(getClass()));
			executeQuery();
			return mappingAll();
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * キーによるデータ取得
	 * @param compcode コマンドユニットコード(検索キー)
	 * @return cm_componentDto 検索結果(DTO)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 */
	public CmComponentDto findForKey(String compcode) throws SQLException, IllegalAccessException, NoSuchFieldException {
		try {
			index = 1;
			prepareStatement(getSelectQuery(getClass()) + getConditionForKey(getClass()));
			setParam(index++, compcode);
			executeQuery();
			CmComponentDto dto = null;
			if (rs.next()) {
				dto = mapping();
				mappingCommonInfo(dto);
			}
			return dto;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * キーによる行ロック取得
	 * @param compcode コマンドユニットコード(検索キー)
	 * @return cm_componentDto 検索結果(DTO)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 */
	public CmComponentDto findForUpdate(String compcode) throws SQLException, IllegalAccessException,
			NoSuchFieldException {
		try {
			index = 1;
			prepareStatement(getSelectQuery(getClass()) + getConditionForKey(getClass()) + getForUpdate());
			setParam(index++, compcode);
			executeQuery();
			CmComponentDto dto = null;
			if (rs.next()) {
				dto = mapping();
				mappingCommonInfo(dto);
			}
			return dto;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * 条件文によるデータ取得
	 * @param compcode 検索コマンドユニットコード
	 * @param division 検索分類
	 * @return List 検索結果(DTOのList)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 */
	public List<?> findForCondition(String compcode, String division) throws SQLException, IllegalAccessException,
			NoSuchFieldException {
		index = 1;
		StringBuffer sb = new StringBuffer();
		sb.append("WHERE ");
		sb.append(MosPDao.like(COL_COMPCODE));
		sb.append("AND ");
		sb.append(MosPDao.like(COL_DIVISION));
		try {
			prepareStatement(getSelectQuery(getClass()) + sb.toString() + getOrderForKey(getClass()));
			setParam(index++, compcode);
			setParam(index++, MosPDao.startWithParam(division));
			executeQuery();
			return mappingAll();
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * 条件文によるデータ取得
	 * @param compcode 検索コマンドユニットコード
	 * @param division 検索分類
	 * @param compname 検索コマンドユニットネーム
	 * @param manage 閲覧権限
	 * @param deleteFlag	検索削除フラグ
	 * @return list 検索結果(DTOのList)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 */
	public List<?> findForCondition(String compcode, String division, String compname, String manage, String deleteFlag)
			throws SQLException, IllegalAccessException, NoSuchFieldException {
		index = 1;
		StringBuffer sb = new StringBuffer();
		sb.append("WHERE ");
		sb.append(MosPDao.like(COL_COMPCODE));
		sb.append("AND ");
		sb.append(MosPDao.like(COL_DIVISION));
		sb.append("AND ");
		sb.append(MosPDao.like(COL_COMPNAME));
		sb.append("AND ");
		sb.append(MosPDao.like(COL_MANAGE));
		if (MosPDao.isNotNull(deleteFlag)) {
			sb.append("AND ");
			sb.append(MosPDao.equal(COL_DELETEFLAG));
		}
		try {
			prepareStatement(getSelectQuery(getClass()) + sb.toString() + getOrderForKey(getClass()));
			setParam(index++, MosPDao.startWithParam(compcode));
			setParam(index++, MosPDao.containsParam(division));
			setParam(index++, MosPDao.containsParam(compname));
			setParam(index++, MosPDao.containsParam(manage));
			if (MosPDao.isNotNull(deleteFlag)) {
				setParam(index++, Integer.parseInt(deleteFlag));
			}
			executeQuery();
			return mappingAll();
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * 条件文によるデータ取得
	 * @param division 検索分類
	 * @return List 検索結果(DTOのList)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 */
	public List<CmComponentDto> findForCondition(String division) throws SQLException, IllegalAccessException,
			NoSuchFieldException {
		index = 1;
		StringBuffer sb = new StringBuffer();
		sb.append("WHERE ");
		sb.append(MosPDao.equal(COL_DIVISION));
		try {
			prepareStatement(getSelectQuery(getClass()) + sb.toString() + getOrderForKey(getClass()));
			setParam(index++, division);
			executeQuery();
			List<CmComponentDto> list = mappingAll();
			return list;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * 条件文によるデータ取得
	 * @param compcode 検索コード
	 * @param division 検索区分
	 * @return dto 検索結果DTO
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 */
	public CmComponentDto findForDto(String compcode, String division) throws SQLException, IllegalAccessException,
			NoSuchFieldException {
		index = 1;
		StringBuffer sb = new StringBuffer();
		sb.append("WHERE ");
		sb.append(MosPDao.equal(COL_COMPCODE));
		sb.append("AND ");
		sb.append(MosPDao.equal(COL_DIVISION));
		try {
			prepareStatement(getSelectQuery(getClass()) + sb.toString() + getOrderForKey(getClass()));
			setParam(index++, compcode);
			setParam(index++, division);
			executeQuery();
			CmComponentDto dto = null;
			if (rs.next()) {
				dto = mapping();
				mappingCommonInfo(dto);
			}
			return dto;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * 条件文によるデータ取得
	 * @param division 検索分類
	 * @return List 検索結果(DTOのList)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 */
	public List<CmComponentDto> findForAvailable(String division) throws SQLException, IllegalAccessException,
			NoSuchFieldException {
		index = 1;
		StringBuffer sb = new StringBuffer();
		sb.append("WHERE ");
		sb.append(MosPDao.deleteFlagOff(COL_DELETEFLAG));
		sb.append("AND ");
		sb.append(MosPDao.equal(COL_DIVISION));
		try {
			prepareStatement(getSelectQuery(getClass()) + sb.toString() + getOrderForKey(getClass()));
			setParam(index++, division);
			executeQuery();
			List<CmComponentDto> list = mappingAll();
			return list;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * 条件文によるデータ取得
	 * @param compcode 検索コード
	 * @return dto 検索結果DTO
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 */
	public CmComponentDto findForComponent(String compcode) throws SQLException, IllegalAccessException,
			NoSuchFieldException {
		index = 1;
		StringBuffer sb = new StringBuffer();
		sb.append("WHERE ");
		sb.append(MosPDao.deleteFlagOff(COL_DELETEFLAG));
		sb.append("AND ");
		sb.append(MosPDao.equal(COL_COMPCODE));
		try {
			prepareStatement(getSelectQuery(getClass()) + sb.toString() + getOrderForKey(getClass()));
			setParam(index++, compcode);
			executeQuery();
			CmComponentDto dto = null;
			if (rs.next()) {
				dto = mapping();
				mappingCommonInfo(dto);
			}
			return dto;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * データ挿入
	 * @param dto 挿入対象DTO
	 * @return int 挿入結果(件数)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 * @throws MospException	MosP例外処理が発生した場合
	 */
	public int insert(CmComponentDto dto) throws SQLException, IllegalAccessException, NoSuchFieldException,
			MospException {
		try {
			index = 1;
			prepareStatement(getInsertQuery(getClass()));
			setParams(dto, true);
			executeUpdate();
			chkInsert(1);
			return cnt;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * データ更新
	 * @param dto 更新対象DTO
	 * @return int 更新結果(件数)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 * @throws MospException	MosP例外処理が発生した場合
	 */
	public int update(CmComponentDto dto) throws SQLException, IllegalAccessException, NoSuchFieldException,
			MospException {
		try {
			index = 1;
			prepareStatement(getUpdateQuery(getClass()));
			setParams(dto, false);
			setParam(index++, dto.getCompCode());
			executeUpdate();
			chkUpdate(1);
			return cnt;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * パラメータ設定
	 * @param dto 更新対象DTO
	 * @param isInsert  挿入文フラグ(true：挿入文、false：更新文)
	 * @throws SQLException SQL例外が発生した場合
	 */
	private void setParams(CmComponentDto dto, boolean isInsert) throws SQLException {
		setParam(index++, dto.getCompCode()); //コマンドユニットコード
		setParam(index++, dto.getDivision()); //分類
		setParam(index++, dto.getCompName()); //コマンドユニットネーム
		setParam(index++, dto.getComponent()); //コマンド
		setParam(index++, dto.getManage()); //閲覧権限
		setParam(index++, dto.getDeleteFlag()); //削除フラグ
		setCommonParams(isInsert);
	}
	
}
